﻿namespace AirBomber
{
    internal class AirplaneCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            var xAirplane = (DrawningAirplane?)(x as DrawningObject);
            var yAirplane = (DrawningAirplane?)(y as DrawningObject);
            if (xAirplane == yAirplane)
            {
                return 0;
            }
            if (xAirplane == null)
            {
                return 1;
            }
            if (yAirplane == null)
            {
                return -1;
            }
            var xEntity = xAirplane.Airplane;
            var yEntity = yAirplane.Airplane;
            var colorWeight = xEntity.BodyColor.ToArgb().CompareTo(yEntity.BodyColor.ToArgb());
            if (colorWeight != 0 || 
                xEntity is not EntityAirBomber xEntityAirBomber || 
                yEntity is not EntityAirBomber yEntityAirBomber)
            {
                return colorWeight;
            }
            return xEntityAirBomber.DopColor.ToArgb().CompareTo(yEntityAirBomber.DopColor.ToArgb());
        }
    }
}